<?php

namespace Modules\Partner\Controllers\Admin;

/** Ajax Request */

use App\Services\Response\ResponseService;
use Exception;
use Illuminate\View\View;
use Illuminate\Http\Request;
use Illuminate\Http\JsonResponse;
use App\Http\Controllers\Controller;
use Modules\Partner\Requests\Admin\PartnerRequest;
use Modules\Partner\Services\PartnerService;

class PartnerController extends Controller
{

    /** Redirect to this path after each operation success*/
    private $redirectSuccessPath= '/admin/partners';
    /** View folder */
    private $viewDirectory= 'admin.partners.';
    //

    public function __construct(
        private PartnerService $partnerService,
    )
    {}

    /**
     * Display a listing of the partners.
     *
     * @param Request $request
     * @return View
     */
    public function index(Request $request) :View
    {
        $title= __('partners.head');
        return view($this->viewDirectory.'index', get_defined_vars());
    }

    /**
     * return data of the partners.
     *
     * @param Request $request
     * @return View
     */
    public function grid(Request $request) :View
    {
        $request->merge(['paginate'=>true]);
        $partners= $this->partnerService->get($request->all());

        return view($this->viewDirectory.'grid',get_defined_vars());
    }

    /**
     * Show the form for creating a new Partner.
     *
     * @return View
     */
    public function create() :View
    {
        $action= route('partners.store');
        $head= __('partners.new');
        return view( $this->viewDirectory.'form', get_defined_vars() );
    }

    /**
     * Store a newly created Partner in storage.
     * @param PartnerRequest $request
     * @return JsonResponse
     */
    public function store(PartnerRequest $request) :JsonResponse
    {
        $this->partnerService->create($request->validated());

        session()->flash('message', __('dashboard.saveDone'));
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('partners.index'),
        ];
        return ResponseService::response($response);
    }

    /**
     * Show the form for editing the specified Partner.
     *
     * @param  int $id
     * @return View
     */
    public function edit(int $id) :View
    {
        $partner = $this->partnerService->getItem($id);
        if (!$partner)
        {
            abort(404);
        }
        $action= route('partners.update', $partner->id);
        $head= __('partners.edit');
        return view( $this->viewDirectory.'form', get_defined_vars() );
    }

    /**
     * Update the specified Partner in storage.
     * @param PartnerRequest $request
     * @param int $id
     * @return JsonResponse
     */
    public function update(PartnerRequest $request, int $id) :JsonResponse
    {
        $partner = $this->partnerService->checkItem($id);
        if (!$partner)
        {
            abort(404);
        }
        $this->partnerService->update($request->validated(), $id);
        session()->flash('message', __('dashboard.saveDone'));
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('partners.index'),
        ];
        return ResponseService::response($response);
    }

    /**
     * Remove the specified Partner from storage.
     * @param int $id
     * @return JsonResponse
     * @throws Exception
     */
    public function destroy(int $id) :JsonResponse
    {
        $this->partnerService->destroy($id);
        session()->flash('message', __('dashboard.saveDone'));
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('partners.index'),
        ];
        return ResponseService::response($response);
    }

    /**
     * Remove several partners by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function destroyAll(Request $request) :JsonResponse
    {
        $this->partnerService->destroyAll([
            'ids' => $request->ids,
            'status' => 1
        ]);
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('partners.index'),
        ];
        return ResponseService::response($response);
    }

    /**
     * Restore the specified Partner from storage.
     *
     * @param int $id
     * @return JsonResponse
     */
    public function restore(int $id) :JsonResponse
    {
        $this->partnerService->destroy($id);
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('partners.index'),
        ];
        return ResponseService::response($response);
    }

    /**
     * Restore several partners by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function restoreAll(Request $request) :JsonResponse
    {
        $this->partnerService->destroyAll([
            'ids' => $request->ids,
            'status' => 0
        ]);
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('partners.index'),
        ];
        return ResponseService::response($response);
    }
}
